package test.model;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

import org.springframework.data.domain.Persistable;

@Entity
public class Foo implements Persistable<Long> {
	
	private static final long serialVersionUID = 6677607256121084732L;
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;
	
	@OneToMany(fetch = FetchType.LAZY, cascade = { CascadeType.ALL }, orphanRemoval = true)
	private List<Bar> bars;
	
	public void setId(final Long id) {
		this.id = id;
	}
	
	@Override
	public Long getId() {
		return this.id;
	}
	
	public List<Bar> getBars() {
		return this.bars;
	}
	
	public void setBars(final List<Bar> bars) {
		this.bars = bars;
	}
	
	public void addBar(final Bar bar) {
		if (this.bars == null) {
			this.bars = new ArrayList<Bar>(1);
		}
		this.bars.add(bar);
	}
	
	@Override
	public boolean isNew() {
		return null == this.id;
	}
	
}
