package test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertNotNull;

import java.util.List;

import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import test.model.Bar;
import test.model.Foo;
import test.repository.BarRepository;
import test.repository.FooRepository;

@ContextConfiguration
@RunWith(SpringJUnit4ClassRunner.class)
public class LazyLoadingTests {
	
	@Autowired
	private FooRepository fooRepository;
	
	@Autowired
	private BarRepository barRepository;
	
	//@PersistenceContext
	//private EntityManager entityManager;
	
	@Before
	public void before() {
		this.fooRepository.deleteAll();
		this.barRepository.deleteAll();
	}
	
	@Test
	public void testAddBars() {
		Foo foo = new Foo();
		final Bar bar = new Bar("first bar");
		foo.addBar(bar);
		final Bar otherBar = new Bar("another bar");
		foo.addBar(otherBar);
		this.fooRepository.save(foo);
		
		foo = this.fooRepository.findOne(foo.getId());
		final List<Bar> bars = foo.getBars();
		assertNotNull("bar list is null", bars);
		assertFalse("bar list is empty", bars.isEmpty());
		assertEquals(bar, bars.get(0));
		assertEquals(otherBar, bars.get(1));
	}
	
	@Ignore
	@Test
	public void testGetBars() {
		final Foo foo = this.fooRepository.findOne(Long.valueOf(9L));
		final List<Bar> bars = foo.getBars();
		assertNotNull("bar list is null", bars);
		assertFalse("bar list is empty", bars.isEmpty());
	}
	
}
